<template>
  <dashboard-layout title="DetailSubmission" class="backG">
    <div class="container-fluid mt-5">
      <div class="p-5" v-if="isLoading" style="margint-top: 200px;">
        <fulfilling-bouncing-circle-spinner class="mx-auto" :animation-duration="2000"
          :size="60" :color="'#005C96'" />
      </div>
      <div v-else>
        <!-- <button class="mt-5" @click="edit = true" >test</button> -->
        <!-- show submission -->
        <div v-if="!edit" class="container">
          <!-- submission -->
          <div class="row">
            <div class="col-lg-12">
              <div class="card card-margin">
                <!-- head -->
                <div class="d-flex justify-content-between card-header no-border" >
                  <div class="p-2">
                    <div>
                      <!-- oldReviewers {{oldReviewers}} | countReviewers {{countReviewers}}  -->
                      <h5 class="card-title" v-if="currentSubmission">{{ currentSubmission.title }} </h5>
                    </div>
                    <span v-if="currentSubmission"> {{currentSubmission.date | prettyDate(currentSubmission.date)}} </span>
                  </div>
                  <div class="p-2" v-if="currentSubmission">
                    <div class="" >
                      <span v-if="role === 'reviewer'">
                        <i v-if="( inReviewersList && !canSeeReviews && (!deadlinePast || ( dayCountBeforeDeadline === 1 && deadlinePast === true)))"  
                          @click="makeReview(currentId)" class="las la-pencil-alt icon-big" data-toggle="tooltip" data-placement="top" title="Faire la review !">
                        </i>
                      </span> <!-- && deadlinePast && currentReviewing !=  null -->
                      <i v-if=" role === 'admin' " @click="edit = true" 
                          class="las la-clipboard-check icon-big" data-toggle="tooltip" data-placement="top" title="Editer la décision finale !" ></i> 
                    </div>
                  </div>
                </div>
                <!-- body -->
                <div class="card-body pt-0 mt-3">
                  <div class="widget-49">
                    <div class="widget-49-title-wrapper">
                      <div class="widget-49-date-primary">
                        <span v-if="currentSubmission.author">
                          <img :src="currentSubmission.author.pictures[0]"
                            v-if="currentSubmission.author.pictures[0] != null" width="80"  height="80"
                            class="img-profile rounded-circle"
                          />
                          <img :src="'https://yelumi.s3.us-east-2.amazonaws.com/koala.png'" v-else  width="80" height="80"
                            class="img-profile rounded-circle"
                          />
                        </span> 
                        
                        <!-- <span class="widget-49-date-month">apr</span> -->
                      </div>
                      <div class="widget-49-meeting-info ml-3">
                        <span class="widget-49-pro-title"
                          ><strong>
                            <h4 v-if="currentSubmission.author"> 
                              {{ currentSubmission.author.firstname }}
                              {{ currentSubmission.author.lastname }}
                            </h4>
                          </strong>
                          <span v-if="currentSubmission"> {{ currentSubmission.author.profession }} </span>
                        </span>
                      </div>
                    </div>
                    <p class="mt-4"  v-if="currentSubmission">{{ currentSubmission.summary }}</p>
                    <div class="widget-49-meeting-action">
                      <a  v-if="currentSubmission" :href="currentSubmission.files[0]"
                        class="btn btn-sm btn-flash-border-primary" >Télécharger le document associé </a>
                    </div>
                    <hr />
                    <div class="row">
                      <div class="col-8">
                        <strong class="ml-5"> Commentaire final après examen</strong>
                        <br />
                        <span v-if="currentSubmission">{{  currentSubmission.reviewingComments ? currentSubmission.reviewingComments  : "Aucun"  }}</span>  
                      </div>
                      <div class="col-4">
                        <h3 v-if="currentSubmission">
                          <p v-if="currentSubmission.status" class="text-success"  >
                            <b> Approuvé</b>
                          </p>
                          <p v-else class="text-danger">
                            <b v-if="currentSubmission">{{ currentSubmission.reviewingComments ? "Non Approuvé": "En attente"}}</b>
                          </p>
                        </h3>
                        
                        <span><h5><b v-if="currentSubmission">{{currentSubmission.globalMark ? currentSubmission.globalMark : '' }}</b></h5></span>
                      </div>
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </div>
          <!-- review -->
          <div class="row">
            <div class="col-12">
              <div class="card card-margin">
                <!-- head -->
                <div class="d-flex justify-content-between card-header no-border">
                  <div class="p-2 mt-2">
                    <h2>Reviews</h2> <small>Vous ne pouvez pas ajouter plus de 4 personnes pour la review</small> <br> <br>
                    <strong class="text-danger" v-if="currentReviewing"> Deadline: {{ currentReviewing.deadline ?  prettyDate(currentReviewing.deadline) : 'Néant' }}</strong> <br>
                    <strong v-if="currentReviewing">Note finale:  {{ currentReviewing.globalMark ? currentReviewing.globalMark : 'Néant' }}</strong>
                  </div>
                  <div class="form-group col-sm-4 mt-3">
                    <span v-if="role === 'admin'">
                      <span>  </span> <br>
                      <!-- {{countReviewers}} <br>  {{dayCountBeforeDeadline}} <br>  {{deadlinePast ? 'true' : 'false'}} <br> {{oldReviewers ? 'true' : 'false'}} <br>  -->
                      <button v-if="(countReviewers < 4 && !deadlinePast) || (currentReviewing ===  null) || 
                          (countReviewers < 4 && dayCountBeforeDeadline === -1 && deadlinePast === true)"  
                          type="button" class="btn btn-light btn-block" @click="open">
                            Ajouter reviewer</button> 
                      <span v-else> Vous ne pouvez plus ajouter de reviewers !</span>
                    </span>
                    
                    <!-- Modal -->
                    <div id="ourModal" class="d-none ourmodalclass" style="width: 130%; height: 50%; margin: auto">
                      <div class="modal-dialog">
                        <div class="modal-content">
                          <div class="modal-header">
                            <slot name="header">
                              <strong><h4>Ajout Nouveau Reviewer</h4></strong>
                            </slot>
                            <button type="button" class="btn-close" @click="closeOurModal">
                              <i class="las la-times-circle big-icon"></i>
                            </button>
                          </div> 
                          <section class="modal-body">
                            <div class="m-5" v-if="isLoading1">
                              <fulfilling-bouncing-circle-spinner class="mx-auto" :animation-duration="2000"
                                :size="60" :color="'#005C96'"  />
                            </div>
                            <div v-else>
                              <div class="alert alert-danger" v-if="errorMessage">{{ errorMessage }}</div>
                              <form @submit="addReviewer" class="mt-12" >
                                <div class="form-group col-12 mx-auto" v-if="oldReviewers === false">
                                  <label class="">Deadline</label> 
                                  <input type="date" class="form-control" v-model="newReviewer.deadline" />
                                </div>
                                <div class="form-group col-12 mx-auto" v-if="reviewers">
                                  <label class="">Reviewer</label>
                                  <v-select :options="reviewers" :reduce="(item) => item.code" 
                                    class="form-control-select" v-model="newReviewer.id" required >
                                  </v-select>
                                </div>
                                <div class="modal-footer "> <button type="submit" class="btn btn-light btn-block">Enregistrer</button></div>
                              </form>
                            </div>
                          </section>
                        </div>
                      </div>
                    </div> 
                    <!-- End Modal -->
                  </div>
                </div>
                <hr>
                <!-- body -->
                <div class="card-body">
                  <div v-if="currentReviewing">
                    <!-- list of reviews -->
                    <div class="table-responsive">
                      <table class="table rounded">
                        <thead>
                          <th>Reviewer</th>
                          <th>Résumé</th>
                          <th>Commentaire</th>
                          <th>Note</th>
                          <th></th>
                        </thead>
                        <tbody>
                          <tr v-for="(review, i) in currentReviewing.reviewers" :key="i">   
                            <td v-if="role === 'reviewer'  && canSeeReviews "> {{ review.reviewer.firstname }} {{ review.reviewer.lastname }} <br>{{ review.reviewer.profession }} </td>
                            <td v-if="role === 'reviewer'  && canSeeReviews "> {{ review.summary ? review.summary : 'Néant' }} </td>
                            <td v-if="role === 'reviewer'  && canSeeReviews "> {{ review.comment ? review.comment : 'Néant' }} </td>
                            <td v-if="role === 'reviewer'  && canSeeReviews "> {{ review.mark ? review.mark : 'Néant' }} </td>
                          
                            <td v-if="role === 'admin'">{{review.reviewer.lastname}} {{review.reviewer.firstname}} <br> {{review.reviewer.profession}} </td>
                            <td v-if="role === 'admin'">  {{ review.summary ? review.summary : 'Néant' }} </td>
                            <td v-if="role === 'admin'"> {{ review.comment ? review.comment : 'Néant' }} </td>
                            <td v-if="role === 'admin'"> {{ review.mark ? review.mark : 'Néant' }} </td>
                            <!--<td v-if="role === 'admin' ">
                                <button type="button" class="btn btn-warning btn-sm"><i class="las la-paper-plane" style="font-size:15px;"></i>Rappel</button>
                            </td>-->
                          </tr> 
                        </tbody>
                      </table>
                    </div>
                  </div>
                  <div v-else>
                    <h4><div class="text-center">Aucune review !!!</div></h4>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
        <!-- edit -->
        <div class="card col-6 mx-auto" v-if="edit" style="margin-top: 100px;">
          <slot name="header">
            <strong class="mx-auto mt-5"><h4>Décision après évaluation</h4></strong>
          </slot>
          <div class="m-5" v-if="isLoading2">
            <fulfilling-bouncing-circle-spinner class="mx-auto" :animation-duration="2000"
              :size="60" :color="'#005C96'"  />
          </div>
          <div v-else>
            <div class="alert alert-danger" v-if="errorMessage">{{ errorMessage }}</div>
            <form @submit="editSubmission" class="col-6 mx-auto" >
              <div class="form-group mx-auto" >
                <label class="">Note Globale</label>
                <v-select class="form-control-select" v-model="globalMark" required 
                  :options="[{label: 'Acceptable', code: 'acceptable'}, {label: 'Bien', code: 'bien'},
                  {label: 'Très Bien', code: 'tresbien'} ]"></v-select>
              </div> 
              <div class="form-group mx-auto" >
                <label class="">Statut</label>
                <v-select class="form-control-select" v-model="editCurrentSubmission.status" required 
                  :options="[{label: 'Accepté', code: true},{label: 'Rejeté', code: false} ]"></v-select>
              </div>
              <div class="form-group mx-auto" >
                <label class="">Commentaire</label>
                <textarea class="form-control" rows="4" v-model="editCurrentSubmission.reviewingComments" required></textarea>
              </div>
              <div class="modal-footer  col-6 mx-auto"> <button type="submit" class="btn btn-light btn-block">Enregistrer</button></div>
            </form>
          </div> 
        </div>
      </div>
    </div>
  </dashboard-layout>
</template>





<script>
import moment from 'moment';

export default { 
  data() {
    return {
      role: "",
      currentUserId: '',
      canSeeReviews: false,
      inReviewersList: false,

      errorMessage: "",
      currentId: "",
      currentSubmission: null,
      currentReviewing: null,

      isLoading: false,
      isLoading1: false,
      isLoading2: false,
      edit: false,
      
      searchtext: "",
      searchtype: "",
      curPage: 1,
      perPage: 100,

      newReviewer: {
        deadline: "",
        id: "",
      },
      oldReviewers: false,
      reviewers: null,
      countReviewers: 0,
      dayCountBeforeDeadline: 0,
      deadlinePast: false,
      editCurrentSubmission: {
        status: "",
        reviewingComments: "",
      },
      globalMark: "",
    };
  },
  mounted() {
    this.init()
  },
  methods: {
    init(){
      this.currentId = this.$route.params.id;
      if (this.currentId){
        this.loadSubmission();
      }
      if (localStorage.getItem("token")) {
        console.log( localStorage.getItem("adminRole") );
        this.currentUserId = localStorage.getItem("adminId");
        this.role = localStorage.getItem("adminRole");
        if(this.role == "admin") this.canSeeReviews = true;
        console.log('canSeeReviews: ',this.canSeeReviews) 
      } 
      this.getReviewers();
    },
    loadSubmission() {
      this.isLoading = true;    
      this.$service.load("submissions", this.currentId, (err, data) => {
        // this.isLoading = false; 
        if (err) {
          this.errorMessage = err.data && err.data.message;
          return;
        }
        if (data.submission) {
          this.currentSubmission = data.submission;
          console.log("-------- currentSubmission: ",this.currentSubmission);
          this.loadReview();
        }
      });
    },

    loadReview() {
      // this.isLoading = true;
      let query = {
        options: { submission: this.currentId, },
        filter: {
          text: this.searchtext,
          type: this.searchtype.split("+"),
        },
        sort: {},
        page: this.curPage - 1,
        perPage: this.perPage,
      };
      this.$service.list("reviews", query, (err, data) => {
        if (err) { this.isLoading = false; this.errorMessage = err.data && err.data.message; return; }
        if (data.reviews[0]) {
          this.currentReviewing = data.reviews[0];
          if(this.currentReviewing.reviewers.length >= 1){this.oldReviewers = true;} 
          if( this.currentReviewing.deadline ){ 
            this.dayCountBeforeDeadline = this.diffDay(this.currentReviewing.deadline) 
            this.deadlinePast = this.pastDate(this.currentReviewing.deadline)
          }         
          // console.log("-------- load review: ",this.currentReviewing);
          if(this.currentReviewing.reviewers){
            this.currentReviewing.reviewers.forEach((value, index) => {
              //be sur that the reviewer already make her review 
              if(value.reviewer == this.currentUserId) {
                this.inReviewersList = true; 
                if(value.comment != null) this.canSeeReviews = true;
              }
                
              console.log('canSeeReviews: ',this.canSeeReviews)
              this.countReviewers += 1;
              // console.log("--------------------- ",this.loadDetailsAdmin(value.reviewer))
              let query = {
                options: {
                  _id: value.reviewer,
                },
                sort: {},
                page: 0,
                perPage: 100,
              };
              this.$service.listAdmins(query, (err, data) => {
                if (err) { console.log('error: ', err); return; }
                if (data.admins[0]) {
                  // console.log('data: ', data.admins[0]);
                  this.currentReviewing.reviewers[index].reviewer = data.admins[0]
                }
              });
            });
          }
          console.log("-------- currentReviewing: ",this.currentReviewing,'oldReviewers: ',this.oldReviewers ); 
          this.isLoading = false;
        }else{
          // console.log('no reviews for the submisison',this.currentReviewing,'oldReviewers: ',this.oldReviewers )
          this.isLoading = false;
        }
      }); 
    },

    addReviewer(e) {
      e.preventDefault();
      // console.log(this.newReviewer);
      this.errorMessage = "";
      this.isLoading1 = true; 
      if (this.oldReviewers) {
        let tab = []//this.currentReviewing.reviewers;
        // console.log("tab: ", tab, "review", this.currentReviewing)
        let findReviewer = false; 
        this.currentReviewing.reviewers.forEach((value, index) => {
          // console.log(index,value,this.newReviewer.id);
          let object = {};
          object.reviewer = value.reviewer._id;
          if(value.mark){
            object.mark = value.mark; object.summary = value.summary; object.comment = value.comment;
          }
          tab.push(object)
          if (value.reviewer._id === this.newReviewer.id){
            console.log(" ============= old reviewer found ");
            findReviewer = true; 
            this.isLoading1 = false;
            this.errorMessage = "Le reviewer est déjà ajouté pour cette soumission !";
            return;
          }  
        });
        //console.log(" ============= findReviewer : ",findReviewer);
        if(findReviewer === false){
          tab.push({reviewer: this.newReviewer.id,})
          let datas = {
            reviewers: tab,
            deadline: this.currentReviewing.deadline, 
          };
          
          console.log(" ============= datas : ",datas,this.currentReviewing._id);
          
          this.$service.update("reviews",this.currentReviewing._id,datas, "add reviewer", (err, data) => {
            if (err) {
              this.errorMessage = err.data && err.data.message;
              return;
            }
            console.log("add reviewer data: ", data);
            this.isLoading1 = false;
            if(data){
              this.$swal.fire("Ajout effectué !", "", "success").then(() => {
                this.closeOurModal();
              });
            }
          });
        }
      }else{
        let tab = [{reviewer: this.newReviewer.id,}];
        let datas = {
          submission: this.currentSubmission.id,
          deadline: this.newReviewer.deadline,
          reviewers: tab,
        };
        this.$service.create("reviews", datas, (err, data) => {
          if (err) {  this.errorMessage = err.data && err.data.message; return;  }
          console.log("add reviewer data: ", data);
          this.isLoading1 = false;
          this.$swal.fire("Ajout effectué !", "", "success").then(() => {
            this.closeOurModal();
          });
        });
      }
    },
    editSubmission(e){
      e.preventDefault();
      this.isLoading2 = true;
      console.log(this.editCurrentSubmission, this.globalMark)

      this.$service.update("submissions",this.currentSubmission.id,
        {'status': this.editCurrentSubmission.status.code, 
          'reviewingComments': this.editCurrentSubmission.reviewingComments,
          'globalMark': this.globalMark.code, 'reviewId': this.currentReviewing._id},"add global mark", (err, data) => {
        if (err) { this.errorMessage = err.data && err.data.message; return; }
        this.isLoading2 = false 
        console.log("edit submission submission data: ", data);

        if(data){
          this.$swal.fire("Modification effectuée !", "", "success").then(() => {
            this.closeEdit();
          });
        
          //console.log('have sub'); //this.setGlobalMark() 
          // console.log(this.currentReviewing._id, this.globalMark.code)
          // this.$service.update("reviews",this.currentReviewing._id,{'globalMark':this.globalMark.code}," ", (err1, data1) => {
          //   if (err1) { this.errorMessage = err.data && err.data.message; return; }
          //   console.log("edit submission review data: ", data1);
          //   this.isLoading2 = false; 
          //   //console.log('Set global mark')
          //   if(data1){
          //     this.$swal.fire("Modification effectuée !", "", "success").then(() => {
          //       this.closeEdit();
          //     });
          //   }
          // }); 
        }
      });
    },
    // setGlobalMark(){
    //   console.log(this.currentReviewing._id, this.globalMark.code)  
    //   this.$service.update("reviews",this.currentReviewing._id,{'globalMark':this.globalMark.code}," ", (err1, data1) => {
    //     if (err1) { this.errorMessage = err.data && err.data.message; return; }
    //     console.log("edit submission review data: ", data1);
    //     this.isLoading2 = false; 
    //     //console.log('Set global mark')
    //     if(data1){
    //       this.$swal.fire("Modification effectuée !", "", "success").then(() => {
    //         this.closeEdit();
    //       });
    //     }
    //   });
    // },
    getReviewers() {
      this.isLoading = true;
      this.errorMessage = "";
      let query = {
        options: { role: "reviewer", },
        sort: {},
        page: 0,
        perPage: 100,
      };
      this.$service.listAdmins(query, (err, data) => {
        this.isLoading = false;
        if (err) { console.log(err); return; }
        if (data.admins) {
          this.reviewers = data.admins.map((admin) => {
            return {
              label:
                admin.firstname +
                " " +
                admin.lastname +
                " |   " +
                admin.profession,
              code: admin._id,
            };
          });
          console.log("-------- reveiwers: ",this.reviewers ); 
        }
      });
    }, 
    hasClass(element, cls) {
      return (' ' + element.className + ' ').indexOf(' ' + cls + ' ') > -1;
    },
    open(){
      var element = document.getElementById('ourModal');
      if(this.hasClass(element, 'd-none') ){
        element.classList.remove('d-none');
      }
      else{
       element.classList.add('d-none');
      }
    },
    closeOurModal(){
      var element = document.getElementById('ourModal');
      element.classList.add('d-none');
      this.errorMessage = '';
      this.newReviewer= {
        deadline: "",
        id: ""
      };
      this.init();
    },
    prettyDate(value){
       moment.locale('fr');
    return moment(value).utcOffset(1).format('DD MMMM YYYY');
    },
    closeEdit(){
      this.edit = false;
      this.loadSubmission();
    },
    diffDay(day){
      let today = moment();
      console.log( today.diff(day, 'days') )
      this.countDay = today.diff(day, 'days')
      return today.diff(day, 'days');
    },
    pastDate(day){
      if (moment().isBefore(day)) {
          this.deadlinePast = false;
          console.log('Date is not past',this.deadlinePast);

      }else{
          this.deadlinePast = true;
          console.log('Date is past',this.deadlinePast);
      }
    },
    makeReview(id) {
      this.$router.push({ path: "/review/" + id });
    },
    checkIfExist(value){
      console.log('value: ',value)
      if(value.comment){
        return true      
      } else {return false}
    }
  },
};
</script>





<style scoped>
body {
  background: #f4f7fd;
  margin-top: 20px;
}

.card-margin {
  margin-bottom: 1.875rem;
}

.card {
  border: 0;
  box-shadow: 0px 0px 10px 0px rgba(82, 63, 105, 0.1);
  -webkit-box-shadow: 0px 0px 10px 0px rgba(82, 63, 105, 0.1);
  -moz-box-shadow: 0px 0px 10px 0px rgba(82, 63, 105, 0.1);
  -ms-box-shadow: 0px 0px 10px 0px rgba(82, 63, 105, 0.1);
}
.card {
  position: relative;
  display: flex;
  flex-direction: column;
  min-width: 0;
  word-wrap: break-word;
  background-color: #ffffff;
  background-clip: border-box;
  border: 1px solid #e6e4e9;
  border-radius: 8px;
}

.card .card-header.no-border {
  border: 0;
}
.card .card-header {
  background: none;
  padding: 0 0.9375rem;
  font-weight: 500;
  display: flex;
  align-items: center;
  min-height: 50px;
}
.card-header:first-child {
  border-radius: calc(8px - 1px) calc(8px - 1px) 0 0;
}

.widget-49 .widget-49-title-wrapper {
  display: flex;
  align-items: center;
}

.widget-49 .widget-49-title-wrapper .widget-49-date-primary {
  display: flex;
  align-items: center;
  justify-content: center;
  flex-direction: column;
  background-color: #edf1fc;
  width: 4rem;
  height: 4rem;
  border-radius: 50%;
}

.widget-49
  .widget-49-title-wrapper
  .widget-49-date-primary
  .widget-49-date-day {
  color: #4e73e5;
  font-weight: 500;
  font-size: 1.5rem;
  line-height: 1;
}

.widget-49
  .widget-49-title-wrapper
  .widget-49-date-primary
  .widget-49-date-month {
  color: #4e73e5;
  line-height: 1;
  font-size: 1rem;
  text-transform: uppercase;
}

.widget-49 .widget-49-title-wrapper .widget-49-date-secondary {
  display: flex;
  align-items: center;
  justify-content: center;
  flex-direction: column;
  background-color: #fcfcfd;
  width: 4rem;
  height: 4rem;
  border-radius: 50%;
}

.widget-49
  .widget-49-title-wrapper
  .widget-49-date-secondary
  .widget-49-date-day {
  color: #dde1e9;
  font-weight: 500;
  font-size: 1.5rem;
  line-height: 1;
}

.widget-49
  .widget-49-title-wrapper
  .widget-49-date-secondary
  .widget-49-date-month {
  color: #dde1e9;
  line-height: 1;
  font-size: 1rem;
  text-transform: uppercase;
}

.widget-49 .widget-49-title-wrapper .widget-49-date-success {
  display: flex;
  align-items: center;
  justify-content: center;
  flex-direction: column;
  background-color: #e8faf8;
  width: 4rem;
  height: 4rem;
  border-radius: 50%;
}

.widget-49
  .widget-49-title-wrapper
  .widget-49-date-success
  .widget-49-date-day {
  color: #17d1bd;
  font-weight: 500;
  font-size: 1.5rem;
  line-height: 1;
}

.widget-49
  .widget-49-title-wrapper
  .widget-49-date-success
  .widget-49-date-month {
  color: #17d1bd;
  line-height: 1;
  font-size: 1rem;
  text-transform: uppercase;
}

.widget-49 .widget-49-title-wrapper .widget-49-date-info {
  display: flex;
  align-items: center;
  justify-content: center;
  flex-direction: column;
  background-color: #ebf7ff;
  width: 4rem;
  height: 4rem;
  border-radius: 50%;
}

.widget-49 .widget-49-title-wrapper .widget-49-date-info .widget-49-date-day {
  color: #36afff;
  font-weight: 500;
  font-size: 1.5rem;
  line-height: 1;
}

.widget-49 .widget-49-title-wrapper .widget-49-date-info .widget-49-date-month {
  color: #36afff;
  line-height: 1;
  font-size: 1rem;
  text-transform: uppercase;
}

.widget-49 .widget-49-title-wrapper .widget-49-date-warning {
  display: flex;
  align-items: center;
  justify-content: center;
  flex-direction: column;
  background-color: floralwhite;
  width: 4rem;
  height: 4rem;
  border-radius: 50%;
}

.widget-49
  .widget-49-title-wrapper
  .widget-49-date-warning
  .widget-49-date-day {
  color: #ffc868;
  font-weight: 500;
  font-size: 1.5rem;
  line-height: 1;
}

.widget-49
  .widget-49-title-wrapper
  .widget-49-date-warning
  .widget-49-date-month {
  color: #ffc868;
  line-height: 1;
  font-size: 1rem;
  text-transform: uppercase;
}

.widget-49 .widget-49-title-wrapper .widget-49-date-danger {
  display: flex;
  align-items: center;
  justify-content: center;
  flex-direction: column;
  background-color: #feeeef;
  width: 4rem;
  height: 4rem;
  border-radius: 50%;
}

.widget-49 .widget-49-title-wrapper .widget-49-date-danger .widget-49-date-day {
  color: #f95062;
  font-weight: 500;
  font-size: 1.5rem;
  line-height: 1;
}

.widget-49
  .widget-49-title-wrapper
  .widget-49-date-danger
  .widget-49-date-month {
  color: #f95062;
  line-height: 1;
  font-size: 1rem;
  text-transform: uppercase;
}

.widget-49 .widget-49-title-wrapper .widget-49-date-light {
  display: flex;
  align-items: center;
  justify-content: center;
  flex-direction: column;
  background-color: #fefeff;
  width: 4rem;
  height: 4rem;
  border-radius: 50%;
}

.widget-49 .widget-49-title-wrapper .widget-49-date-light .widget-49-date-day {
  color: #f7f9fa;
  font-weight: 500;
  font-size: 1.5rem;
  line-height: 1;
}

.widget-49
  .widget-49-title-wrapper
  .widget-49-date-light
  .widget-49-date-month {
  color: #f7f9fa;
  line-height: 1;
  font-size: 1rem;
  text-transform: uppercase;
}

.widget-49 .widget-49-title-wrapper .widget-49-date-dark {
  display: flex;
  align-items: center;
  justify-content: center;
  flex-direction: column;
  background-color: #ebedee;
  width: 4rem;
  height: 4rem;
  border-radius: 50%;
}

.widget-49 .widget-49-title-wrapper .widget-49-date-dark .widget-49-date-day {
  color: #394856;
  font-weight: 500;
  font-size: 1.5rem;
  line-height: 1;
}

.widget-49 .widget-49-title-wrapper .widget-49-date-dark .widget-49-date-month {
  color: #394856;
  line-height: 1;
  font-size: 1rem;
  text-transform: uppercase;
}

.widget-49 .widget-49-title-wrapper .widget-49-date-base {
  display: flex;
  align-items: center;
  justify-content: center;
  flex-direction: column;
  background-color: #f0fafb;
  width: 4rem;
  height: 4rem;
  border-radius: 50%;
}

.widget-49 .widget-49-title-wrapper .widget-49-date-base .widget-49-date-day {
  color: #68cbd7;
  font-weight: 500;
  font-size: 1.5rem;
  line-height: 1;
}

.widget-49 .widget-49-title-wrapper .widget-49-date-base .widget-49-date-month {
  color: #68cbd7;
  line-height: 1;
  font-size: 1rem;
  text-transform: uppercase;
}

.widget-49 .widget-49-title-wrapper .widget-49-meeting-info {
  display: flex;
  flex-direction: column;
  margin-left: 1rem;
}

.widget-49
  .widget-49-title-wrapper
  .widget-49-meeting-info
  .widget-49-pro-title {
  color: #3c4142;
  font-size: 14px;
}

.widget-49
  .widget-49-title-wrapper
  .widget-49-meeting-info
  .widget-49-meeting-time {
  color: #b1bac5;
  font-size: 13px;
}

.widget-49 .widget-49-meeting-points {
  font-weight: 400;
  font-size: 13px;
  margin-top: 0.5rem;
}

.widget-49 .widget-49-meeting-points .widget-49-meeting-item {
  display: list-item;
  color: #727686;
}

.widget-49 .widget-49-meeting-points .widget-49-meeting-item span {
  margin-left: 0.5rem;
}

.widget-49 .widget-49-meeting-action {
  text-align: right;
}

.widget-49 .widget-49-meeting-action a {
  text-transform: uppercase;
}
</style>